--- old/usr/src/lib/libc/port/threads/thr.c	2017-06-05 18:56:14.200060296 +0000
+++ new/usr/src/lib/libc/port/threads/thr.c	2017-06-05 18:56:14.230079287 +0000
@@ -22,6 +22,7 @@
 /*
  * Copyright (c) 1999, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright (c) 2016 by Delphix. All rights reserved.
+ * Copyright (c) 2017 by The MathWorks, Inc. All rights reserved.
  */
 /*
  * Copyright 2016 Joyent, Inc.
@@ -777,9 +778,14 @@
 	}
 	lmutex_unlock(&udp->link_lock);
 
-	tmem_exit();		/* deallocate tmem allocations */
+	/*
+	 * tsd_exit() may call its destructor free(), thus depending on
+	 * tmem, therefore tmem_exit() needs to be called after tsd_exit()
+	 * and tls_exit().
+	 */
 	tsd_exit();		/* deallocate thread-specific data */
 	tls_exit();		/* deallocate thread-local storage */
+	tmem_exit();		/* deallocate tmem allocations */
 	heldlock_exit();	/* deal with left-over held locks */
 
 	/* block all signals to finish exiting */
